// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.gear;

/*
 * #%L
 * SIH-Adagio :: Core for Allegro
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 - 2013 Ifremer
 * %%
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * #L%
 */


/**
 * <p>
 * Une classification d'engin permet le regroupement d'un ensemble
 * cohérent d'engin.
 * </p>
 * <p>
 * Exemple :
 * </p>
 * <p>
 * - Engin FAO, appellée aussi CSITEP (Classification Standard
 * Internationale Type des Engins de Pêche), ou, en anglais :
 * International Standard Statistical Classification of Fishing
 * Gear (ISSCFG) :
 * ftp://ftp.fao.org/FI/DOCUMENT/cwp/handbook/annex/AnnexM1fishinggear.pdf
 * </p>
 * <p>
 * - Engin CNTS (DPMA SIP)
 * </p>
 * <p>
 * - Engin EU (basé sur les engins FAO, mais adapté au contexte
 * réglementaire européen) :
 * </p>
 * <p>
 * exemple : 	- extension pour signifier 'pas d'engin' : NO
 * </p>
 * <p>
 * extension pour signifier 'engin inconnu' : NK (Not Known)
 * </p>
 * <p>
 * 'ligne avec canne (...)' : BTF (code utilisé pour des données
 * historique)
 * </p>
 * <p>
 * - 'Engin EU Corpus' pour le traitment (cf DRE_CORPUS dans
 * tmpsih)
 * </p>
 * <p>
 * - Engin Métier Ifremer (basé sur la classification FAO, et
 * etendue aux besoins Ifremer/francais)
 * </p>
 * <p>
 * Pour ObsMer, la classification utilisée est : FAO
 * </p>
 * <p>
 * Pour les observations au débarquement, la classification
 * utilisée est : FAO + CNTS (pour recroiser avec les déclarations)
 * </p>
 */
public abstract class GearClassification
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1749412795194260087L;

    private java.lang.Integer id;

    /**
     * 
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String name;

    /**
     * 
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.String description;

    /**
     * 
     */
    public java.lang.String getDescription()
    {
        return this.description;
    }

    public void setDescription(java.lang.String description)
    {
        this.description = description;
    }

    private java.lang.Boolean isAggregation = java.lang.Boolean.valueOf(false);

    /**
     * <p>
     * <html>
     * </p>
     * <p>
     * <head>
     * </p>
     * <p>
     * </head>
     * </p>
     * <p>
     * <body>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * TODO : confirmer si l'attribut est utile
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * , dans la mesure ou les strat&#233;gies peuvent permettrent de
     * choisir la
     * </p>
     * <p>
     * classification &#224; utiliser.<br>
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * <p>
     * </p>
     * <p>
     * Indicateur permettant de savoir si la classification est
     * utilis&#233;
     * </p>
     * <p>
     * uniquement dans le cadre de donn&#233;es d'agr&#233;gation.
     * </p>
     * <p>
     * </p>
     * </p>
     * <p>
     * </body>
     * </p>
     * <p>
     * </html>
     * </p>
     */
    public java.lang.Boolean getIsAggregation()
    {
        return this.isAggregation;
    }

    public void setIsAggregation(java.lang.Boolean isAggregation)
    {
        this.isAggregation = isAggregation;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.gear.Gear> gears = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.gear.Gear>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.gear.Gear> getGears()
    {
        return this.gears;
    }

    public void setGears(java.util.Collection<fr.ifremer.adagio.core.dao.referential.gear.Gear> gears)
    {
        this.gears = gears;
    }




    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof GearClassification))
        {
            return false;
        }
        final GearClassification that = (GearClassification)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.gear.GearClassification}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.gear.GearClassification}.
         */
        public static fr.ifremer.adagio.core.dao.referential.gear.GearClassification newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.gear.GearClassification entity = new fr.ifremer.adagio.core.dao.referential.gear.GearClassificationImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.gear.GearClassification}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.gear.GearClassification newInstance(java.lang.String name, java.lang.Boolean isAggregation)
        {
            final fr.ifremer.adagio.core.dao.referential.gear.GearClassification entity = newInstance();
            entity.setName(name);
            entity.setIsAggregation(isAggregation);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.gear.GearClassification}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.gear.GearClassification newInstance(java.lang.String name, java.lang.String description, java.lang.Boolean isAggregation, java.sql.Timestamp updateDate, java.util.Collection<fr.ifremer.adagio.core.dao.referential.gear.Gear> gears)
        {
            final fr.ifremer.adagio.core.dao.referential.gear.GearClassification entity = newInstance();
            entity.setName(name);
            entity.setDescription(description);
            entity.setIsAggregation(isAggregation);
            entity.setUpdateDate(updateDate);
            entity.setGears(gears);
            return entity;
        }
    }
    
// GearClassification.java merge-point
}